#include "fbs_database.h"

int tccmpFbs(const char *ptr1, int size1, const char *ptr2, int size2, void *op){
  assert(ptr1 && ptr2);
  //  maxlink_types::Fbs fbs1;
  //  maxlink_types::Fbs fbs2;
  assert(size1 == sizeof(maxlink_types::Fbs));
  assert(size2 == sizeof(maxlink_types::Fbs));
  const maxlink_types::Fbs *fbs_ptr1 = reinterpret_cast<const maxlink_types::Fbs *>(ptr1); 
  const maxlink_types::Fbs *fbs_ptr2 =  reinterpret_cast<const maxlink_types::Fbs *>(ptr2); 
  int ret = 0;

  // This comparison function is sorting in the reversed order. 
  // We use the fbs-cutoff as a filter for strictly "greater than" instead 
  // of "greater than or equal", so we reverse the comparison "<" to ">".
  // The reason for this is that the num_edges_over_cutoff() uses tcbdbcurjump(). 
  // 
  // From the Tokyo Cabinet documentation:
  // http://fallabs.com/tokyocabinet/spex-en.html#tcbdbapi
  //  About  tcbdbcurjump():
  // "The cursor is set to the first record corresponding the key or the next substitute if completely
  //  matching record does not exist."
  
  if (*fbs_ptr1 > *fbs_ptr2) { 
    ret = -1;
  }
  if (*fbs_ptr1 < *fbs_ptr2) { 
    ret = 1;
  }
  return ret;
}
