#!/usr/bin/perl -T 
use warnings;
use strict;
use Switch;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use IPC::Open2;
use IPC::Open3;
use Scalar::Util qw(tainted);

my $version = "FC3"; #version of FunCoup to be used
my ($result,$result2,$pid,$pid2);
$result = "";
$result2 = "";

my $cgi = new CGI;
if ($cgi->cgi_error()) {
  die()
};
$ENV{'PATH'} = '/bin:/usr/bin';
$ENV{'LD_LIBRARY_PATH'} = '';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
print  	$cgi->header(),
    	$cgi->start_html(
			-title=>'MaxLink',
			-style=>{-src=>'http://funcoup2.sbc.su.se/funcoup_styles_clean.css'},		
			-head=>meta({-http_equiv => 'Content-Type', content => 'text/html'})),
	'<body style="background-color: rgb(255, 255, 255);" lang="en-US">
	<div id="center">
		<div id="top">
			<div id="logo"> MaxLink logo<br></div>
			<div id="sbclogo"> <img style="border: 0px solid ; width: 128px; height: 116px;" src="http://www.sbc.su.se/furniture/sbclogo.png" alt="Sbc logotype"></div>
			<div id="menu">
			<table class="medium" border="0">
			<tbody>
			<tr>
				<td width="200"><a href="http://maxlink.sbc.su.se/" target="_blank">MaxLink home</a></td>
				<td width="200"><a href="http://maxlink.sbc.su.se/MaxlinkHelp.html" target="_blank">Documentation</a></td>
				<td width="250"><a href="http://funcoup.sbc.su.se/statistics/" target="_blank">Network statistics</a></td>
				<td width="200"><a href="http://maxlink.sbc.su.se/download/" target="_blank">Download</a></td>
				<td width="100"><a href="http://www.ncbi.nlm.nih.gov/pubmed/19959820" target="_blank">Citation</a></td>
			</tr>
			</tbody>
			</table>
		</div>
	</div>',
	$cgi->start_form(-method=>'POST'),
	'<table class="colored_bg3 noborder">
	<tbody>
		<tr valign="top">
			<td class="large bold table_pad" style="white-space: nowrap; vertical-align: top;">Query network
			<a title="The species network you want to search with your query" target="_blank" class="big_question">?</a>

			<br></td>
			<td class="table_pad" align="left" valign="top">
        			<select name="for_species" id="fspec" onchange="setListOfSelect(&#39;fcc&#39;, &#39;fspec&#39;, &#39;FCclasses&#39;); hideOrShowSpan(&#39;fspec&#39;, &#39;zfish_id&#39;, &#39;zfish&#39;)">
        			<option value="hsapiens">Homo sapiens</option>
			        <option value="mmusculus">Mus musculus</option>
        			<option value="rnorvegicus">Rattus norvegicus</option>
			        <option value="cfamiliaris">Canis familiaris</option>
			        <option value="ggallus">Gallus gallus</option>
			        <option value="drerio">Danio rerio</option>
			        <option value="cintestinalis">Ciona intestinalis</option>
			        <option value="dmelanogaster">Drosophila melanogaster</option>
			        <option value="celegans">Caenorhabditis elegans</option>
			        <option value="scerevisiae">Saccharomyces cerevisiae</option>
			        <option value="athaliana">Arabidopsis thaliana</option>
        			</select>
        			<span class="large bold"></span>
        		</td>
			<td valign="right" align="left" rowspan="7" class="table_pad"> <span class="large bold">Find genes:
			<a title="Enter Ensemble IDs i.e ensg00000185627 (one per line)" class="big_question"> ?</a>
			</span><br><br>
			        <textarea id="textfield" cols="50" style="height: 145px;" rows="20" name="query"></textarea><br><br>
				<p><a onclick="document.getElementById(\'textfield\').value=document.getElementById(\'textfield\').value + \'ensg00000142208\' + \'\n\' + \'ensg00000012048\' + \'\n\' + \'ensg00000139618\' + \'\n\' + \'ensg00000136492\' + \'\n\' + \'ensg00000183765\' + \'\n\' + \'ensg00000100393\' + \'\n\' + \'ensg00000083093\' + \'\n\' + \'ensg00000139687\' + \'\n\' + \'ensg00000141510\';"><button type="button">Example</button></a>';
print reset;
print $cgi->submit();
print '</p>
	</td></tr>
		<td class="large bold table_pad" style="white-space: nowrap; vertical-align: top;">Confidence threshold <a href="http://maxlink.sbc.su.se/MaxlinkHelp.html" title="Enter the network confidence threshold between 0 and 1" target="_blank" class="big_question">?</a><br>
        	</td>
        	<td class="table_pad" align="left" valign="top"> <input name="cutoff" value="0.75" size="10" maxlength="10" type="text">
        	</td>
	</tr>
	<tr>
		<td class="large bold table_pad" style="white-space: nowrap; vertical-align: top;">Hypergeometric cutoff <a href="http://maxlink.sbc.su.se/MaxlinkHelp.html" title="Enter desired hypergeometric cutoff" target="_blank" class="big_question">?</a><br>
		</td>
        	<td class="table_pad" align="left" valign="top"><input name="pvalueCutoff" value="0.1" size="10" maxlength="10" type="text">
        	</td>
	</tr>
	</tbody>	
		<td>Questions? Ask <a href="mailto:dimitri.guala@scilifelab.se">Dimitri Guala</a></td> 
	</table>
	<br>';
    $cgi->end_form,
    $cgi->hr;
if ($cgi->param) {
    my ($content, $pfc, $fbscutoff, $hypergeometric_probability_cutoff, $method, $networkId);

    my $format ="xml";
    my $top = 608;
    $method = "hypergeometric";

    #Network
    if ( $cgi->param('for_species')=~/^(.+)$/s ) {
	$networkId = $1;
    } else {
        $networkId = "hsapiens";
    }
    
    #PFC (network confidence threshold)
    if ( $cgi->param('cutoff')=~/^([0-9]*\.[0-9]+)$/s ) {
        $pfc = $1;
    } else {
        $pfc = 0.75;
    }
    my $fbs = log(1000)-log((1/$pfc)-1);
    $fbscutoff = sprintf("%.1f", $fbs);

    #Method of ML
    if ( $cgi->param('pvalueCutoff')=~/^([0-1]*\.[0-9]+|[0-9]+)$/s ) {
       	$hypergeometric_probability_cutoff = $1; 
    } else {
      	$hypergeometric_probability_cutoff = 0.1;
    }

    #List of FC identifiers (check if present)
    if ( $cgi->param('query')=~/^(.+)$/s ) {
        $content = $1; 
    } else {
        print "error: No query sent";
        exit(0);
    }

    $content =~ s/\r\n/\n/g;
    $content = lc($content);

    print $cgi->hr;
    my($child_out, $child_in, $child_err);
    use Symbol 'gensym'; $child_err = gensym;

    $pid = open3( $child_in, $child_out, $child_err, "/var/www/maxlink.sbc.su.se/installed_from_cmake_build/bin/maxlink-query1","-d","/var/www/maxlink.sbc.su.se/installed_from_cmake_build/var/lib/maxlink/tokyocabinet_data/$version/$networkId","-n", "/dev/stdin","--output-format","$format","--fbs-cutoff","$fbscutoff","--result-method","hypergeometric","--probability-cutoff","$hypergeometric_probability_cutoff");

    print $child_in $content;
    close($child_in);
    while(<$child_out>) { 
	$result = $result .  $_;
    }
    my $err = "";
    while(<$child_err>) {
	$err = $err . $_ ."<br/>";
    }
    waitpid($pid,0);
    my($child_out2, $child_in2, $child_err2);
    $child_err2 = gensym;
    $pid2 = open3( $child_in2, $child_out2, $child_err2, "@xsltproc_EXECUTABLE@","@xslt_install_dir@/createhtml.xsl","-");
    print $child_in2 $result;

    close($child_in2);
    while(<$child_out2>) { 
	if(($top -= 1) >= 0)
	{
		$result2 = $result2 .  $_;
	}
    }
    my $err2 = "";
    while(<$child_err2>) {
	$err2 = $err2 . $_;
    }
    waitpid($pid2,0);
	print '<br/>';
	print '<table class="colored_bg3 noborder">';
	print '<tbody>';
	print "<td class=\"large bold table_pad\" style=\"white-space: nowrap; vertical-align: top;\">";
	print "Query</br>(Confidence=$pfc, hypergeometric=$hypergeometric_probability_cutoff)";
	print "</td>";
	print "<td class=\"table_pad\" align=\"left\">";

	$content =~ s/\n/<br\/>/g;
	$content =~ s/<br\/>/, /g;

	print $content."</td>";
	$content =~ s/ //g;

	my $network = "human";
	my ($start, $mid, $end);
	if ($version eq "FC2")
	{
		switch ($networkId) {
			case "hsapiens"		{ $network = "human" }
			case "mmusculus"	{ $network = "mouse" }
			case "rnorvegicus"	{ $network = "rat" }
			case "cfamiliaris"	{ $network = "dog" }
			case "ggallus"		{ $network = "chicken" }
			case "drerio"		{ $network = "zfish" }
			case "cintestinalis"	{ $network = "Ciona" }
			case "dmelanogaster"	{ $network = "fly" }
			case "celegans"		{ $network = "worm" }
			case "scerevisiae"	{ $network = "yeast" }
			case "athaliana"	{ $network = "Arabidopsis" }
		}	    

		$start = "http://funcoup2.sbc.su.se/cgi-bin/bring_subnet.fc2.cgi?genes=";
		$mid = "&context_genes=";
	    	$end = "&for_species=$network&show_names=Names&fc_class=all&Run=Run&keggmap=KEGG00010&context_genes=&base=all&ortho_render=no&coff=$pfc&order=1&reduce=yes&no_of_links=30&reduce_by=noislets&qvotering=quota&show_names=Names&keep_query=yes&java=1&jsquid_screen=no&wwidth=1000&wheight=700&structured_table=yes&single_table=yes";
	} elsif ($version eq "FC3")
	{
		switch ($networkId) {
			case "hsapiens"		{ $network = "22" }
			case "mmusculus"	{ $network = "12" }
			case "rnorvegicus"	{ $network = "32" }
			case "cfamiliaris"	{ $network = "92" }
			case "ggallus"		{ $network = "52" }
			case "drerio"		{ $network = "72" }
			case "cintestinalis"	{ $network = "82" }
			case "dmelanogaster"	{ $network = "62" }
			case "celegans"		{ $network = "102" }
			case "scerevisiae"	{ $network = "42" }
			case "athaliana"	{ $network = "112" }
		}
		$start = "http://funcoup.sbc.su.se/search/network.action?query.geneQuery=";
		$mid = "&query.primaryGenomeID=$network&query.confidenceThreshold=$pfc&query.depth=1&query.nodesPerStep=200&__checkbox_query.prioritizeNeighbors=true&query.expansionAlgorithm=local&__checkbox_query.addKnownCouplings=true&query.individualEvidenceOnly=true&__checkbox_query.individualEvidenceOnly=true&query.categoryID=-1&query.constrainEvidence=no&query.restriction=genes&query.relationalGenes=";
	    	$end = "&query.showAdvanced=false";
    	}
    my @rows=split(/\n/,$result2);
    my $resultGenes="";
	if ($version eq "FC2")
	{
	    	foreach my $line (@rows)
		{
			if($line=~/<td>(\D+\d+)<\/td>/)
			{
				$resultGenes .= "$1,";
			}
		}
	}
    elsif ($version eq "FC3")
	{
		$content =~ s/,/%2C/g;	
		foreach my $line (@rows){
			if($line=~/<td>(\D+\d+)<\/td>/){
			$resultGenes .= "$1%2C";
			}
		}	
	}
	
    my $FCurl = $start . $content . $mid. $resultGenes. $end;
    
    print "<tr><td class=\"large bold table_pad\" align=\"left\" valign=\"top\" width=\"195\">Result (H.sapiens):</td>
	       <td><a href=$FCurl target=\"_blank\">FunCoup Network of queries and results</a></td>
	   <tr/></tbody></table><br/>";

    print "$result2";
    print "<br/>";
    if ($err) {print "<br/>With the error messages:<br/>".$err . "<br/>";}
    print '<div/>';
    print $cgi->end_html;
}

























